# -*- coding: utf-8 -*-
"""multi_object_colision.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1i2J2aZzj63z0sFykgFqbmg6ATJhN4ZZ6

Please note that whole script is written in a little suboptimal way performing not necesairy calculations to allow structurised operations conducted by numpy on arrays. Avoiding `if`s and loops allows faster execution with use of umpy vecorisation instead of using standard python exectuin flow that is noticibly slower.

**Units**

Implemented formulas are valid for data provided in a following units.

To use different units it may be needed to scale their values

```
Force -> N
Velocity -> m/s
Mass -> kg
Time -> s
Distance -> m
Acceleration -> m/s2
```
"""

from typing import Callable
import numpy as np

"""## Code used to compute the motion dynamics due to newtonian laws

**DONE**
"""

# ##############################################################################
# Functions related to the equations of motion, modeling dynamics of motion
# These are auxiliary functions not modifying the arguments. They follow the
# functional paradigm

def motion_uniform_component(vx,vy,dt):
  """
  Function calculates traveled distance for uniform rectilinear component of the
  motion

  Function is compatibile with the numpy arrays

  @param vx X component of velocity
  @param vy Y component of velocity
  @param dt Time difference
  @return dx,dy - traveled distance in X and Y directions respectively
  """
  dx = vx*dt
  dy = vy*dt
  return dx, dy

def motion_accelerated_component(ax,ay,dt):
  """
  Function calculates traveled distance for accelerated rectilinear component of
  the motion

  Function is compatibile with the numpy arrays

  @param ax X component of acceleration
  @param ay Y component of acceleration
  @param dt Time difference
  @return dx,dy - traveled distance in X and Y directions respectively
  """
  t2 = dt**2
  dx = ax*t2/2
  dy = ay*t2/2
  return dx,dy


def velocity_diff(ax,ay,dt):
  """
  Function computes the difference of velocity induced by the acceleration

  Function is compatibile with the numpy arrays

  @param ax X component of acceleration
  @param ay Y component of acceleration
  @param dt Time difference
  @return dvx,dvy - Difference in X and Y components of velocity after dt time
  """
  dvx = ax*dt
  dvy = ay*dt
  return dvx,dvy


def motion_timestep(x,y,vx,vy,ax,ay,dt):
  """
  Function that computes next position of an object taking into consideration:
  current position, unifiorm motion and accelerated motion. It computes also the
  resulting velocity after applying acceleration.

  Function is compatibile with the numpy arrays

  @param x X coordinate of the object
  @param y Y coordinate of the object
  @param vx X component of object's velovity
  @param vy Y component of object's velocity
  @param ax X component of object's acceleration
  @param xy Y component of object's acceleration
  @return new_x, new_y, new_vx, new_vy - X,Y coordinates and X,Y components of
          velocity that are result of simulation according to arguments
  """
  dx1, dy1 = motion_uniform_component(vx,vy,dt)
  dx2, dy2 = motion_accelerated_component(ax,ay,dt)
  new_x = x+dx1+dx2
  new_y = y+dy1+dy2

  dvx, dvy = velocity_diff(ax,ay,dt)
  new_vx =  vx+dvx
  new_vy = vy+dvy

  return new_x, new_y, new_vx, new_vy

def compute_acceleration(force, mass):
  """
  Function responsible for computing acceleration that is result of applying
  force to the object.

  Differently that upper formulas it operates only in 1st dimension so it to use
  it in 2D space one needs to apply it separately to X and Y component of force

  Function is compatibile with the numpy arrays

  @param force The applied force
  @param mass The mass of the object
  @returns Acceleration induced by acting force

  """
  return force/mass

"""## Code used to compute the logic of colisions

We asume that there at single time there is just single colision - there is no colision of 3 or more objects at exactly the same time

To meet this assumptions dt must be very small

Addidionally in current state code does not simulate time between $t_1$ and $t_2$ where $t_1$ is time when colision has happened and $t_2$ is nearest future time grid point.

**DONE**
"""

# ##############################################################################
# Functions created in order to calculate colisions of objects
# Some of then are written in suboptimal way to allow paralelized execution
# taking advantage of numpy vectorisation
# Functions are written according to functional paradigm not modyfing the values
# of arguments

def cartesian_distance(x1,y1,x2,y2):
  """
  Calculates the cartesian distance between 2 points
  """
  return ((x2-x1)**2 + (y2-y1)**2)**0.5

def is_coliding(x1, x2, y1, y2, r1, r2)->bool:
  """
  Checks if collision happens

  We assume objects are in the shape of circles and if circles do intersect then
  the collision is happening

  Namely if distnace between centers of objects is equal or smaller than sum of
  their radiuses then the colision is happening
  """
  centers_distance = cartesian_distance(x1,y1,x2,y2)
  return r1 + r2 >= centers_distance



def compute_velocities_after_colision(v1x, v1y, v2x, v2y, m1, m2):
  """
  Function computes X and Y components of first object velocity after colision
  with second specified object

  @param v1x X component of first object's velocity
  @param v1y Y component of first object's velocity

  @param v2x X component of second object's velocity
  @param v2y Y component of second object's velocity

  @param m1 Mass of first object
  @param m2 Mass of second object

  @returns new_v1x, new_v1y - X and Y components of first object's velocity
           after the colision
  """
  def formula(v1,v2,m1,m2):
    first_frac = (m1-m2)/(m1+m2)
    second_frac = (2*m2)/(m1+m2)
    return first_frac*v1 + second_frac*v2


  new_v1x = formula(v1x,v2x,m1,m2)
  new_v1y = formula(v1y,v2y,m1,m2)
  return new_v1x, new_v1y


def compute_colisions_dv(x1,x2, y1,y2, v1x, v1y, v2x,v2y, r1,r2,m1,m2):
  """
  Given two objects descriptions, function computes the difference in velocity
  of first object induced by the colision. It does return delta values
  separately for each component of motion

  Function is compatibile with single case and with np.array vectorisation

  @param x1 X Coordinate of 1st object
  @param x2 X Coordinate of 2nd object
  @param y1 Y Coordinate of 1st object
  @param y2 Y Coordinate of 2nd object
  @param v1x X Component of velocity of 1st object
  @param v1y Y Component of velocity of 1st object
  @param v2x X Component of velocity of 2nd object
  @param v2y Y Component of velocity of 2nd object
  @param r1 Radius of 1st object
  @param r2 Radius of 2nd object
  @param m1 Mass of 1st object
  @param m2 Mass of 2nd object

  @return d_v1x, d_v1y - Delta of velocity of 1st object, with respect to its
          original velocity, introduced by colision with second object, or 0 if
          colision does not occur. Values are provided separately for X and Y
          components of velocity
  """

  colision_occurs = is_coliding(x1, x2, y1, y2, r1, r2)

  temp_v1x, temp_v1y = compute_velocities_after_colision(v1x, v1y, v2x, v2y, m1, m2)
  d_v1x = temp_v1x * colision_occurs + v1x * (1-colision_occurs) - v1x
  d_v1y = temp_v1y * colision_occurs + v1y * (1-colision_occurs) - v1y

  return d_v1x, d_v1y


class ObjectColisionPairs:
  """
  Class representing the pairs of objects that may have colision between each other

  After creating the class user may compute effects of colisions
  """

  # First element of pair
  x1  = np.array([])
  y1  = np.array([])
  v1x = np.array([])
  v1y = np.array([])
  r1  = np.array([])
  m1  = np.array([])

  # Second element of pair
  x2  = np.array([])
  y2  = np.array([])
  v2x = np.array([])
  v2y = np.array([])
  r2  = np.array([])
  m2  = np.array([])

  # Auxiliary data on velocity
  # Velocities of all objects
  vx = None
  vy = None

  # Number of pairs for each element
  n_pairs_for_element = None

  # Number of created pairs
  n_pairs = None

  # Number of objects in the system
  n_objects = None

  def __init__(self, x,y,vx,vy,m,r):
    """
    Constructor of the class

    @param x np.array of X coordinates
    @param y np.array of Y coordinates
    @param vx np.array of X component of velocity
    @param vy np.array of Y component of velocity
    @param m np.array of objects' masses
    @param r np.array of objects' radiuses
    """
    x1 , y1 , v1x, v1y, r1 , m1 , x2 , y2 , v2x, v2y, r2 , m2 = self._create_pairs(x,y,vx,vy,m,r)
    self.x1  = x1
    self.y1  = y1
    self.v1x = v1x
    self.v1y = v1y
    self.r1  = r1
    self.m1  = m1
    self.x2  = x2
    self.y2  = y2
    self.v2x = v2x
    self.v2y = v2y
    self.r2  = r2
    self.m2  = m2

    self.vx = vx
    self.vy = vy

    self.n_objects = len(x)
    self.n_pairs_for_element = self.n_objects-1
    self.n_pairs = self.n_objects*self.n_pairs_for_element


  def compute_colisions(self):
    """
    Function compute new velocities after colisions that occured between objects
    It does not take into consideration time between actual colision and next
    time grid point

    @returns new_vx, new_vy New velocities aftef the colision
             (X and Y components)
    """
    # Computing changes in velocity
    d_v1x, d_v1y = compute_colisions_dv(self.x1,self.x2, self.y1,self.y2,
                                        self.v1x, self.v1y, self.v2x,self.v2y,
                                        self.r1,self.r2,self.m1,self.m2)
    # Reducing changes to array of new velocities
    new_vx, new_vy = self._reduce_pair_delta_to_velocities(d_v1x, d_v1y)

    return new_vx, new_vy

  def _create_pairs(self,x,y,vx,vy,m,r):
    """
    Creates all possible colision pairs out of given lists of objects

    Pairs creation procedure is ilustrated below:
    +-------------+---+---+---+---+---+---+---+---+---+---+---+---+
    | 1st element | a | a | a | b | b | b | c | c | c | d | d | d |
    +-------------+---+---+---+---+---+---+---+---+---+---+---+---+
    | 2nd element | b | c | d | a | c | d | a | b | d | a | b | c |
    +-------------+---+---+---+---+---+---+---+---+---+---+---+---+

    Arguments specify properties of objects.

    Function returns specification of pairs in form of a list where all records
    concerning a single pair are located under the same index in all arrays

    First element of pair -> x1 , y1 , v1x, v1y, r1 , m1
    Second element of pair -> x2 , y2 , v2x, v2y, r2 , m2

    x#,y# are current coordinates
    v#x,v#y are velocity components
    r# are radiuses
    m# are masses

    There is a possiblility of slow downs as some parts of code need more
    complicated operations and loops. Additionaly number of created records is
    quadratic with respect to number of delivered objects
    """
    x1  = np.array([])
    y1  = np.array([])
    v1x = np.array([])
    v1y = np.array([])
    r1  = np.array([])
    m1  = np.array([])
    x2  = np.array([])
    y2  = np.array([])
    v2x = np.array([])
    v2y = np.array([])
    r2  = np.array([])
    m2  = np.array([])

    number_of_objects = len(x)
    number_of_pairs_per_object = number_of_objects-1

    # Bottle neck not possible to be vectorised
    for object_index in range(number_of_objects):
      # First element of pair
      first_obj_x = x[object_index]
      first_obj_y = y[object_index]

      first_obj_vx = vx[object_index]
      first_obj_vy = vy[object_index]

      first_obj_r = r[object_index]
      first_obj_m = m[object_index]

      x1  = np.append(x1 , np.repeat(first_obj_x , number_of_pairs_per_object))
      y1  = np.append(y1 , np.repeat(first_obj_y , number_of_pairs_per_object))
      v1x = np.append(v1x, np.repeat(first_obj_vx, number_of_pairs_per_object))
      v1y = np.append(v1y, np.repeat(first_obj_vy, number_of_pairs_per_object))
      r1  = np.append(r1 , np.repeat(first_obj_r , number_of_pairs_per_object))
      m1  = np.append(m1 , np.repeat(first_obj_m , number_of_pairs_per_object))

      # Second element of pair

      x2  = np.append(x2 , np.delete(x , object_index))
      y2  = np.append(y2 , np.delete(y , object_index))
      v2x = np.append(v2x, np.delete(vx, object_index))
      v2y = np.append(v2y, np.delete(vy, object_index))
      r2  = np.append(r2 , np.delete(r , object_index))
      m2  = np.append(m2 , np.delete(m , object_index))

    # End of bottle neck

    return x1 , y1 , v1x, v1y, r1 , m1 , x2 , y2 , v2x, v2y, r2 , m2

  def _reduce_pair_delta_to_velocities(self, d_v1x, d_v1y):
    """
    Reduces list of differences in velocity induced by each pair colision into a
    new velocities of each object in the system.

    More technicaly, it converts output of `compute_colisions_dv` back into an
    array where index is equal to index of object in the system

    Be sure to give the function the **FIRST** element of pair.
    +-------------+---+---+---+---+---+---+---+---+---+---+---+---+
    | 1st element | a | a | a | b | b | b | c | c | c | d | d | d |
    +-------------+---+---+---+---+---+---+---+---+---+---+---+---+
    | 2nd element | b | c | d | a | c | d | a | b | d | a | b | c |
    +-------------+---+---+---+---+---+---+---+---+---+---+---+---+
    As function expect to have elements grouped

    @param d_v1x Deltas of velocity of first element in colison pair introduced
           by colisions - X component
    @param d_v1y Deltas of velocity of first element in colison pair introduced
           by colisions - Y component

    """

    sum_d_vx = np.zeros(self.n_objects)
    sum_d_vy = np.zeros(self.n_objects)

    # Bottle neck not possible to be vectorised
    for pair_index in range(self.n_pairs):
      first_obj_idx = self._pair_index_to_first_obj_index(pair_index)
      sum_d_vx[first_obj_idx] += d_v1x[pair_index]
      sum_d_vy[first_obj_idx] += d_v1y[pair_index]
    # End of bottle neck

    new_vx = sum_d_vx + self.vx
    new_vy = sum_d_vy + self.vy

    return new_vx, new_vy

  def _pair_index_to_first_obj_index(self, pair_idx)->int:
    object_idx = pair_idx//self.n_pairs_for_element
    return object_idx

"""## Code handling borders of simulation

Code used to compute behaviour of objects in contact with simulation borders

**DONE**
"""

# ##############################################################################
# Functions that are computing the behaviour of object that crossed or
# encountered the boundary.
# These are auxiliary functions not modifying the arguments. They follow the
# functional paradigm

def horizontal_symetry(x, y, line_y):
  """
  Applies the symetry with respect to horizontal line

  Against line -------------------

  Function is compatibile with the numpy arrays

  @param x X coordinate of the object
  @param y Y coordinate of the object
  @param line_y Y coordinate of symetry axis
  @return return x, new_y - Coordinates of objects transformed with respect to
          the symetry
  """
  new_y = line_y - (y - line_y )
  return x*1, new_y

def vertical_symetry(x, y, line_x):
  """
  Applies the symetry with respect to vertical line

  | Against line
  |
  |

  Function is compatibile with the numpy arrays

  @param x X coordinate of the object
  @param y Y coordinate of the object
  @param line_x X coordinate of symetry axis
  @return return new_x, y - Coordinates of objects transformed with respect to
          the symetry
  """
  new_x = line_x - (x-line_x)
  return new_x, y*1

def bounce_from_walls(r,x,y,vx,vy, wall_top, wall_right, wall_bottom, wall_left):
  """
  It may be deduced that only component of velocity perpendicular to the wall
  needs to be reflected. Additionaly it means that we need to perform symetric
  transformation of position with respect to the crossed boundary. Reasuming:
  function performs symetric flip along crossed border and reverts velocity
  component perpendicular to the border

  @param r Radius of the object
  @param x X coordinate of the object [m]
  @param y Y coordinate of the object [m]
  @param vx X component of object's velocity [m/s]
  @param vy Y component of object's velocity [m/s]
  @param wall_top Y value of top boundary line [m]
  @param wall_right X value of right boundary line [m]
  @param wall_bottom Y value of bottom boundary line [m]
  @param wall_left X value of left boundary line [m]
  @return new_x, new_y, new_vx, new_vy - Coordinates X,Y and velocity separated
          into X,Y components after simulating bounces from borders of system
  """
  # Function is written in a manner to avoid any `if`s and to operate on numpy
  # vectors

  # Bool vectors indicating what has happened
  crossed_top = y+r >= wall_top
  crossed_right = x+r >= wall_right
  crossed_bottom = y-r <= wall_bottom
  crossed_left = x-r <= wall_left


  center_crossed_top = y >= wall_top
  center_crossed_right = x >= wall_right
  center_crossed_bottom = y <= wall_bottom
  center_crossed_left = x <= wall_left

  # Sneaky copy of arrays
  new_x, new_y = x*1, y*1
  new_vx, new_vy = vx*1, vy*1

  # top border
  temp_x, temp_y = horizontal_symetry(new_x,new_y,wall_top)
  new_x = (1-center_crossed_top)*new_x + center_crossed_top * temp_x # instead of if to operate lineary on vectors
  new_y = (1-center_crossed_top)*new_y + center_crossed_top * temp_y # instead of if to operate lineary on vectors
  new_vy = (1-crossed_top)*new_vy + crossed_top * (-new_vy)


  # right border
  temp_x, temp_y = vertical_symetry(new_x,new_y,wall_right)
  new_x = (1-center_crossed_right)*new_x + center_crossed_right * temp_x # instead of if to operate lineary on vectors
  new_y = (1-center_crossed_right)*new_y + center_crossed_right * temp_y # instead of if to operate lineary on vectors
  new_vx = (1-crossed_right)*new_vx + crossed_right * (-new_vx)

  # bottom border
  temp_x, temp_y = horizontal_symetry(new_x,new_y,wall_bottom)
  new_x = (1-center_crossed_bottom)*new_x + center_crossed_bottom * temp_x # instead of if to operate lineary on vectors
  new_y = (1-center_crossed_bottom)*new_y + center_crossed_bottom * temp_y # instead of if to operate lineary on vectors
  new_vy = (1-crossed_bottom)*new_vy + crossed_bottom * (-new_vy)

  # left border
  temp_x, temp_y = vertical_symetry(new_x,new_y,wall_left)
  new_x = (1-center_crossed_left)*new_x + center_crossed_left * temp_x # instead of if to operate lineary on vectors
  new_y = (1-center_crossed_left)*new_y + center_crossed_left * temp_y # instead of if to operate lineary on vectors
  new_vx = (1-crossed_left)*new_vx + crossed_left * (-new_vx)


  return new_x, new_y, new_vx, new_vy

"""## Code handling field like interacions

"""

class ObjectInteractionPairs:
  x1:np.ndarray
  x2:np.ndarray
  y1:np.ndarray
  y2:np.ndarray
  m1:np.ndarray
  m2:np.ndarray

  def __init__(self,x,y,masses) -> None:
    self.n_objects = len(x)
    self.n_pairs_for_element = self.n_objects-1
    self.n_pairs = self.n_objects*self.n_pairs_for_element

    x1,x2,y1,y2,m1,m2 = self._create_pairs(x,y,masses)
    self.x1 = x1
    self.x2 = x2
    self.y1 = y1
    self.y2 = y2
    self.m1 = m1
    self.m2 = m2
    

  def _create_pairs(self,x,y,m):
    x1 = np.ndarray(0)
    x2 = np.ndarray(0)
    y1 = np.ndarray(0)
    y2 = np.ndarray(0)
    m1 = np.ndarray(0)
    m2 = np.ndarray(0)
    for object_index in range(self.n_objects):
      # First element of pair
      first_obj_x = x[object_index]
      first_obj_y = y[object_index]

      first_obj_m = m[object_index]
      
      x1  = np.append(x1 , np.repeat(first_obj_x , self.n_pairs_for_element))
      y1  = np.append(y1 , np.repeat(first_obj_y , self.n_pairs_for_element))
      m1  = np.append(m1 , np.repeat(first_obj_m , self.n_pairs_for_element))

      # Second element of pair

      x2  = np.append(x2 , np.delete(x , object_index))
      y2  = np.append(y2 , np.delete(y , object_index))
      m2  = np.append(m2 , np.delete(m , object_index))
    return x1,x2,y1,y2,m1,m2
    

  def _compute_pairwise_interaction_on_first_object(self, calculator:Callable):
    Fx,Fy = calculator(self.x1,self.y1,self.m1, self.x2,self.y2,self.m2)
    return Fx, Fy

  def _reduce_pairs(self, Fx, Fy):
    sum_Fx = np.zeros(self.n_objects)
    sum_Fy = np.zeros(self.n_objects)

    # Bottle neck not possible to be vectorised
    for pair_index in range(self.n_pairs):
      first_obj_idx = self._pair_index_to_first_obj_index(pair_index)
      sum_Fx[first_obj_idx] += Fx[pair_index]
      sum_Fy[first_obj_idx] += Fy[pair_index]
    return sum_Fx, sum_Fy

  def compute_interaction_force(self, interaction_calculator:Callable):
    Fx_, Fy_ = self._compute_pairwise_interaction_on_first_object(interaction_calculator)
    Fx, Fy = self._reduce_pairs(Fx_, Fy_)
    return Fx, Fy

  def _pair_index_to_first_obj_index(self, pair_idx)->int:
    object_idx = pair_idx//self.n_pairs_for_element
    return object_idx

def compute_interaction_force(x:np.ndarray,y:np.ndarray,masses:np.ndarray,calculator:Callable = None):
  if calculator is None:
    return 0,0
  oip = ObjectInteractionPairs(x,y,masses)
  Fx, Fy = oip.compute_interaction_force(calculator)
  return Fx, Fy


def compute_interactions_acceleration_subpipe(x:np.ndarray,y:np.ndarray,masses:np.ndarray,calculator:Callable = None):
  Fx, Fy = compute_interaction_force(x,y,masses,calculator)
  ax = compute_acceleration(Fx,masses)
  ay = compute_acceleration(Fy,masses)
  return ax,ay

"""## Code handling set of objects

This is main part of code that is going to be used by end user

Whole simulation is controlled by the object as well as all the data can be accessed by its fields

**DONE**
"""

from collections import namedtuple
SystemBorders = namedtuple('SystemBorders', ['top', 'right', 'bottom', 'left'])

class ObjectsSet:

  def __init__(self,calculator:Callable = None) -> None:
    self.calculator = calculator

    # coordinates of objects [m]
    self.x = np.array([])                      # private?
    self.y = np.array([])                      # private?

    # radius of object [m]
    self.r = np.array([])                      # private?

    # masses of object [kg]
    self.m = np.array([])                      # private?

    # veclocities of objects [ m/s ]
    self.vx = np.array([])                     # private?
    self.vy = np.array([])                     # private?

  # ############################################################################
  # Functions to modify the state of object manualy
  # May be used for initialisation and debug

  def add_object(self, radius, mass, initial_x, initial_y, initial_vx, initial_vy):
    """
    Function adds an object or objects into the system. It may be used as
    initialisation of the system or while simulation is running to add new
    objects that were not yet present.

    @param radius Radius of added object(s)
    @param mass Mass of added object(s)
    @param initial_x Initial location of object(s) - X coordinate
    @param initial_y Initial location of object(s) - Y coordinate
    @param initial_vx Initial velocity of object(s) - X component
    @param initial_vy Initial velocity of object(s) - Y component
    @return None
    """
    self.x = np.append(self.x, initial_x)
    self.y = np.append(self.y, initial_y)

    self.vx = np.append(self.vx, initial_vx)
    self.vy = np.append(self.vy, initial_vy)

    self.m = np.append(self.m, mass)
    self.r = np.append(self.r, radius)

  def modify_position(self, x, y):    # Available only in debug? but public
    """
    Allows to modify positions of objects.

    It is used internally by the simulation, but may be utilised by the user to
    manulay control some aspects of simulation.

    @param x X coordinate of object(s)
    @param y Y coordinate of object(s)
    """
    self.x = x
    self.y = y

  def modify_velocity(self, vx, vy):  # Available only in debug? but public
    """
    Allows to modify velocities of objects.

    It is used internally by the simulation, but may be utilised by the user to
    manulay control some aspects of simulation.

    @param vx X component of objects' velocity
    @param vy Y component of objects' velocity
    """
    self.vx = vx
    self.vy = vy

  # ############################################################################
  # Functions used to proceed in motion
  # They do modify the state of object

  def pipeline_timestep_by_acceleration(self, dt, ax, ay, boundaries:SystemBorders):
    """
    This is function to progress one timestep of simulation, taking into account
    acceleraion values of objects.

    It consists of motion simulation, applying bouncing from borders and
    colisions

    @param dt Timestep [s]
    @param ax X component of acceleration [m/s2]
    @param ay Y component of acceleration [m/s2]
    @param boundaries Borders of simulation - a named tuple
    @return None
    """
    new_x, new_y, new_vx, new_vy = self.compute_postitions_after_timestep_acceleration(dt, ax, ay)
    self.modify_position(new_x,new_y)
    self.modify_velocity(new_vx, new_vy)
    self.pipeline_colision_and_boundaries(boundaries.top, boundaries.right, boundaries.bottom, boundaries.left)

  def pipeline_timestep_by_force(self, dt, Fx, Fy, boundaries:SystemBorders):
    """
    This is function to progress one timestep of simulation, taking into account
    force acting on objects.

    It consists of motion simulation, applying bouncing from borders and
    colisions

    @param dt Timestep [s]
    @param Fx X component of force [N]
    @param Fy Y component of force [N]
    @param boundaries Borders of simulation - a named tuple
    @return None
    """
    new_x, new_y, new_vx, new_vy = self.compute_postitions_after_timestep_force(dt, Fx, Fy)
    self.modify_position(new_x,new_y)
    self.modify_velocity(new_vx, new_vy)
    self.pipeline_colision_and_boundaries(boundaries.top, boundaries.right, boundaries.bottom, boundaries.left)

  def pipeline_colision_and_boundaries(self, wall_top, wall_right, wall_bottom, wall_left):   # private?
    """
    Runs a sequece of actions to handle bounces from borders and colisions that
    are to occur in the current state of objects set.

    It is used internally by mechanics of symulation

    @param wall_top    Location top of the border - Y coordinate of line [m]
    @param wall_right  Location right of the border - X coordinate of line [m]
    @param wall_bottom Location bottom of the border - Y coordinate of line [m]
    @param wall_left   Location left of the border - X coordinate of line [m]
    """

    # Applying boundary conditions of the system
    new_x, new_y, new_vx, new_vy = self.compute_bounce_from_walls(wall_top, wall_right, wall_bottom, wall_left)
    self.modify_position(new_x,new_y)
    self.modify_velocity(new_vx, new_vy)

    # Computing the colisions and applying changes of velocity
    ocp = ObjectColisionPairs(new_x,new_y,new_vx,new_vy,self.m,self.r)
    new_vx, new_vy = ocp.compute_colisions()
    self.modify_velocity(new_vx, new_vy)


  # ############################################################################
  # Functions below take object state as factor but do not change it!
  # they may be used to take see future predictions before making the step
  # They are used to do real steps

  def compute_postitions_after_timestep_acceleration(self,dt,ax=0,ay=0):
    """
    Computes the postions of objects after the timestep, based on provided acceleration
    Uses current position from object state
    """
    dax, day = compute_interactions_acceleration_subpipe(self.x,self.y,self.m, self.calculator)
    new_x, new_y, new_vx, new_vy = motion_timestep(self.x, self.y,self.vx,self.vy,ax+dax,ay+day,dt)
    return new_x, new_y, new_vx, new_vy

  def compute_force_acceleration(self,Fx, Fy):
    """
    Converts force to acceleration with respect to object mass stored in object state
    """
    ax = compute_acceleration(Fx, self.m)
    ay = compute_acceleration(Fy, self.m)
    return ax,ay

  def compute_postitions_after_timestep_force(self,dt,Fx=0,Fy=0):
    """
    Computes the postions of objects after the timestep, based on provided force acting on object
    Uses current position from object state
    """
    ax, ay = self.compute_force_acceleration(Fx,Fy)
    return self.compute_postitions_after_timestep_acceleration(dt,ax,ay)

  def compute_bounce_from_walls(self, wall_top, wall_right, wall_bottom, wall_left):
    """
    Computes positions after bouncing from walls
    Uses current position from object state
    """
    new_x, new_y, new_vx, new_vy = bounce_from_walls(self.r, self.x,self.y,self.vx,self.vy, wall_top, wall_right, wall_bottom, wall_left)

    return new_x, new_y, new_vx, new_vy

"""## Examples of usage

Below there is an example of usage presented

### Deifinition of system
"""

# oset = ObjectsSet()

# # Object 1
# # pos = (1m,1m)
# # mass = 1 kg
# # radius = 0.2m
# # velocity = (1 m/s,1 m/s)

# # Object 2
# # pos = (10m,10m)
# # mass = 1 kg
# # radius = 0.2m
# # velocity = (0 m/s,-1 m/s)


# oset.add_object(radius=np.array([0.2,0.2]),
#                 mass=np.array([1,1]),
#                 initial_x=np.array([1,10]),
#                 initial_y=np.array([1,10]),
#                 initial_vx=np.array([1, 0]),
#                 initial_vy=np.array([1, -1])
#                 )

# # Defining system border
# # top border is y=20
# # bottom border is y=-20
# # left border is x=-30
# # right border is x=30

# boundaries = SystemBorders(top=20,right=30,bottom=-20,left=-30)

# """### Examples of timesteps"""

# # Timestep by acceleration
# # dt = 1 second
# # acceleration = (1 m/s2, 0 m/s2) for all
# # borders as defined

# oset.pipeline_timestep_by_acceleration(dt=1,
#                                        ax=1,
#                                        ay=0,
#                                        boundaries= boundaries)

# # Timestep by gravitation
# # dt = 1 second
# # borders as defined

# oset.pipeline_timestep_by_acceleration(dt=1,
#                                        ax=0,
#                                        ay=-10,
#                                        boundaries=boundaries)

# # Timestep with force
# # Force 5N downwards
# # timestep 1 second

# oset.pipeline_timestep_by_force(dt=1,
#                                 Fx=0,
#                                 Fy=-5,
#                                 boundaries=boundaries)

# """## Some test code"""

# # ...